static const struct { const char *name; OptIndex opt_idx; } option_hash_elems[] = {
  { .name = "ea", .opt_idx = kOptEqualalways },
  { .name = "pa", .opt_idx = kOptPath },
  { .name = "wa", .opt_idx = kOptWriteany },
  { .name = "ma", .opt_idx = kOptModifiable },
  { .name = "eb", .opt_idx = kOptErrorbells },
  { .name = "vb", .opt_idx = kOptVisualbell },
  { .name = "wb", .opt_idx = kOptWritebackup },
  { .name = "sb", .opt_idx = kOptSplitbelow },
  { .name = "cb", .opt_idx = kOptClipboard },
  { .name = "pb", .opt_idx = kOptPumblend },
  { .name = "ic", .opt_idx = kOptIgnorecase },
  { .name = "wc", .opt_idx = kOptWildchar },
  { .name = "cc", .opt_idx = kOptColorcolumn },
  { .name = "sc", .opt_idx = kOptShowcmd },
  { .name = "tc", .opt_idx = kOptTagcase },
  { .name = "uc", .opt_idx = kOptUpdatecount },
  { .name = "gd", .opt_idx = kOptGdefault },
  { .name = "ed", .opt_idx = kOptEdcompatible },
  { .name = "cd", .opt_idx = kOptCdpath },
  { .name = "wd", .opt_idx = kOptWritedelay },
  { .name = "sd", .opt_idx = kOptShada },
  { .name = "qe", .opt_idx = kOptQuoteescape },
  { .name = "ve", .opt_idx = kOptVirtualedit },
  { .name = "re", .opt_idx = kOptRegexpengine },
  { .name = "cf", .opt_idx = kOptConfirm },
  { .name = "ef", .opt_idx = kOptErrorfile },
  { .name = "ff", .opt_idx = kOptFileformat },
  { .name = "nf", .opt_idx = kOptNrformats },
  { .name = "tf", .opt_idx = kOptTtyfast },
  { .name = "hf", .opt_idx = kOptHelpfile },
  { .name = "dg", .opt_idx = kOptDigraph },
  { .name = "bg", .opt_idx = kOptBackground },
  { .name = "ph", .opt_idx = kOptPumheight },
  { .name = "mh", .opt_idx = kOptMousehide },
  { .name = "bh", .opt_idx = kOptBufhidden },
  { .name = "ch", .opt_idx = kOptCmdheight },
  { .name = "wh", .opt_idx = kOptWinheight },
  { .name = "hh", .opt_idx = kOptHelpheight },
  { .name = "sh", .opt_idx = kOptShell },
  { .name = "ci", .opt_idx = kOptCopyindent },
  { .name = "hi", .opt_idx = kOptHistory },
  { .name = "si", .opt_idx = kOptSmartindent },
  { .name = "ai", .opt_idx = kOptAutoindent },
  { .name = "wi", .opt_idx = kOptWindow },
  { .name = "pi", .opt_idx = kOptPreserveindent },
  { .name = "vi", .opt_idx = kOptShada },
  { .name = "ri", .opt_idx = kOptRevins },
  { .name = "ei", .opt_idx = kOptEventignore },
  { .name = "sj", .opt_idx = kOptScrolljump },
  { .name = "hk", .opt_idx = kOptHkmap },
  { .name = "bk", .opt_idx = kOptBackup },
  { .name = "hl", .opt_idx = kOptHighlight },
  { .name = "al", .opt_idx = kOptAleph },
  { .name = "bl", .opt_idx = kOptBuflisted },
  { .name = "tl", .opt_idx = kOptTaglength },
  { .name = "ul", .opt_idx = kOptUndolevels },
  { .name = "ml", .opt_idx = kOptModeline },
  { .name = "rl", .opt_idx = kOptRightleft },
  { .name = "sm", .opt_idx = kOptShowmatch },
  { .name = "pm", .opt_idx = kOptPatchmode },
  { .name = "wm", .opt_idx = kOptWrapmargin },
  { .name = "im", .opt_idx = kOptInsertmode },
  { .name = "tm", .opt_idx = kOptTimeoutlen },
  { .name = "km", .opt_idx = kOptKeymodel },
  { .name = "lm", .opt_idx = kOptLangmenu },
  { .name = "ro", .opt_idx = kOptReadonly },
  { .name = "co", .opt_idx = kOptColumns },
  { .name = "to", .opt_idx = kOptTimeout },
  { .name = "bo", .opt_idx = kOptBelloff },
  { .name = "go", .opt_idx = kOptGuioptions },
  { .name = "so", .opt_idx = kOptScrolloff },
  { .name = "fo", .opt_idx = kOptFormatoptions },
  { .name = "fp", .opt_idx = kOptFormatprg },
  { .name = "ep", .opt_idx = kOptEqualprg },
  { .name = "pp", .opt_idx = kOptPackpath },
  { .name = "mp", .opt_idx = kOptMakeprg },
  { .name = "kp", .opt_idx = kOptKeywordprg },
  { .name = "gp", .opt_idx = kOptGrepprg },
  { .name = "cp", .opt_idx = kOptCompatible },
  { .name = "sp", .opt_idx = kOptShellpipe },
  { .name = "ur", .opt_idx = kOptUndoreload },
  { .name = "sr", .opt_idx = kOptShiftround },
  { .name = "tr", .opt_idx = kOptTagrelative },
  { .name = "ar", .opt_idx = kOptAutoread },
  { .name = "fs", .opt_idx = kOptFsync },
  { .name = "bs", .opt_idx = kOptBackspace },
  { .name = "ts", .opt_idx = kOptTabstop },
  { .name = "ws", .opt_idx = kOptWrapscan },
  { .name = "is", .opt_idx = kOptIncsearch },
  { .name = "js", .opt_idx = kOptJoinspaces },
  { .name = "ss", .opt_idx = kOptSidescroll },
  { .name = "ls", .opt_idx = kOptLaststatus },
  { .name = "et", .opt_idx = kOptExpandtab },
  { .name = "ft", .opt_idx = kOptFiletype },
  { .name = "bt", .opt_idx = kOptBuftype },
  { .name = "ut", .opt_idx = kOptUpdatetime },
  { .name = "pt", .opt_idx = kOptPastetoggle },
  { .name = "nu", .opt_idx = kOptNumber },
  { .name = "su", .opt_idx = kOptSuffixes },
  { .name = "ru", .opt_idx = kOptRuler },
  { .name = "pw", .opt_idx = kOptPumwidth },
  { .name = "aw", .opt_idx = kOptAutowrite },
  { .name = "ww", .opt_idx = kOptWhichwrap },
  { .name = "sw", .opt_idx = kOptShiftwidth },
  { .name = "lw", .opt_idx = kOptLispwords },
  { .name = "tw", .opt_idx = kOptTextwidth },
  { .name = "ex", .opt_idx = kOptExrc },
  { .name = "dy", .opt_idx = kOptDisplay },
  { .name = "lz", .opt_idx = kOptLazyredraw },
  { .name = "sta", .opt_idx = kOptSmarttab },
  { .name = "awa", .opt_idx = kOptAutowriteall },
  { .name = "sua", .opt_idx = kOptSuffixesadd },
  { .name = "cia", .opt_idx = kOptCompleteitemalign },
  { .name = "crb", .opt_idx = kOptCursorbind },
  { .name = "rdb", .opt_idx = kOptRedrawdebug },
  { .name = "swb", .opt_idx = kOptSwitchbuf },
  { .name = "wfb", .opt_idx = kOptWinfixbuf },
  { .name = "scb", .opt_idx = kOptScrollbind },
  { .name = "cuc", .opt_idx = kOptCursorcolumn },
  { .name = "enc", .opt_idx = kOptEncoding },
  { .name = "stc", .opt_idx = kOptStatuscolumn },
  { .name = "fic", .opt_idx = kOptFileignorecase },
  { .name = "imc", .opt_idx = kOptImcmdline },
  { .name = "inc", .opt_idx = kOptInclude },
  { .name = "wic", .opt_idx = kOptWildignorecase },
  { .name = "smc", .opt_idx = kOptSynmaxcol },
  { .name = "tgc", .opt_idx = kOptTermguicolors },
  { .name = "spc", .opt_idx = kOptSpellcapcheck },
  { .name = "bkc", .opt_idx = kOptBackupcopy },
  { .name = "rlc", .opt_idx = kOptRightleftcmd },
  { .name = "fdc", .opt_idx = kOptFoldcolumn },
  { .name = "smd", .opt_idx = kOptShowmode },
  { .name = "hid", .opt_idx = kOptHidden },
  { .name = "ead", .opt_idx = kOptEadirection },
  { .name = "acd", .opt_idx = kOptAutochdir },
  { .name = "mfd", .opt_idx = kOptMaxfuncdepth },
  { .name = "mmd", .opt_idx = kOptMaxmapdepth },
  { .name = "mod", .opt_idx = kOptModified },
  { .name = "imd", .opt_idx = kOptImdisable },
  { .name = "fde", .opt_idx = kOptFoldexpr },
  { .name = "sxe", .opt_idx = kOptShellxescape },
  { .name = "mle", .opt_idx = kOptModelineexpr },
  { .name = "sdf", .opt_idx = kOptShadafile },
  { .name = "def", .opt_idx = kOptDefine },
  { .name = "spf", .opt_idx = kOptSpellfile },
  { .name = "eof", .opt_idx = kOptEndoffile },
  { .name = "swf", .opt_idx = kOptSwapfile },
  { .name = "mef", .opt_idx = kOptMakeef },
  { .name = "inf", .opt_idx = kOptInfercase },
  { .name = "isf", .opt_idx = kOptIsfname },
  { .name = "udf", .opt_idx = kOptUndofile },
  { .name = "tpf", .opt_idx = kOptTermpastefilter },
  { .name = "ruf", .opt_idx = kOptRulerformat },
  { .name = "vif", .opt_idx = kOptShadafile },
  { .name = "wig", .opt_idx = kOptWildignore },
  { .name = "tag", .opt_idx = kOptTags },
  { .name = "hlg", .opt_idx = kOptHelplang },
  { .name = "cdh", .opt_idx = kOptCdhome },
  { .name = "pvh", .opt_idx = kOptPreviewheight },
  { .name = "cwh", .opt_idx = kOptCmdwinheight },
  { .name = "wfh", .opt_idx = kOptWinfixheight },
  { .name = "wmh", .opt_idx = kOptWinminheight },
  { .name = "ari", .opt_idx = kOptAllowrevins },
  { .name = "imi", .opt_idx = kOptIminsert },
  { .name = "fdi", .opt_idx = kOptFoldignore },
  { .name = "bri", .opt_idx = kOptBreakindent },
  { .name = "isi", .opt_idx = kOptIsident },
  { .name = "bsk", .opt_idx = kOptBackupskip },
  { .name = "brk", .opt_idx = kOptBreakat },
  { .name = "wak", .opt_idx = kOptWinaltkeys },
  { .name = "isk", .opt_idx = kOptIskeyword },
  { .name = "spk", .opt_idx = kOptSplitkeep },
  { .name = "sel", .opt_idx = kOptSelection },
  { .name = "cul", .opt_idx = kOptCursorline },
  { .name = "scl", .opt_idx = kOptSigncolumn },
  { .name = "eol", .opt_idx = kOptEndofline },
  { .name = "fcl", .opt_idx = kOptFoldclose },
  { .name = "csl", .opt_idx = kOptCompleteslash },
  { .name = "tcl", .opt_idx = kOptTabclose },
  { .name = "tal", .opt_idx = kOptTabline },
  { .name = "lpl", .opt_idx = kOptLoadplugins },
  { .name = "ssl", .opt_idx = kOptShellslash },
  { .name = "stl", .opt_idx = kOptStatusline },
  { .name = "sol", .opt_idx = kOptStartofline },
  { .name = "spl", .opt_idx = kOptSpelllang },
  { .name = "fml", .opt_idx = kOptFoldminlines },
  { .name = "fdl", .opt_idx = kOptFoldlevel },
  { .name = "gtl", .opt_idx = kOptGuitablabel },
  { .name = "gfm", .opt_idx = kOptGrepformat },
  { .name = "efm", .opt_idx = kOptErrorformat },
  { .name = "icm", .opt_idx = kOptInccommand },
  { .name = "ttm", .opt_idx = kOptTtimeoutlen },
  { .name = "com", .opt_idx = kOptComments },
  { .name = "shm", .opt_idx = kOptShortmess },
  { .name = "wcm", .opt_idx = kOptWildcharm },
  { .name = "wim", .opt_idx = kOptWildmode },
  { .name = "tpm", .opt_idx = kOptTabpagemax },
  { .name = "msm", .opt_idx = kOptMkspellmem },
  { .name = "lrm", .opt_idx = kOptLangremap },
  { .name = "slm", .opt_idx = kOptSelectmode },
  { .name = "fdm", .opt_idx = kOptFoldmethod },
  { .name = "gfn", .opt_idx = kOptGuifont },
  { .name = "cin", .opt_idx = kOptCindent },
  { .name = "syn", .opt_idx = kOptSyntax },
  { .name = "fen", .opt_idx = kOptFoldenable },
  { .name = "bin", .opt_idx = kOptBinary },
  { .name = "fdn", .opt_idx = kOptFoldnestmax },
  { .name = "cpo", .opt_idx = kOptCpoptions },
  { .name = "emo", .opt_idx = kOptEmoji },
  { .name = "mco", .opt_idx = kOptMaxcombine },
  { .name = "spo", .opt_idx = kOptSpelloptions },
  { .name = "fdo", .opt_idx = kOptFoldopen },
  { .name = "sbo", .opt_idx = kOptScrollopt },
  { .name = "dip", .opt_idx = kOptDiffopt },
  { .name = "hkp", .opt_idx = kOptHkmapp },
  { .name = "cmp", .opt_idx = kOptCasemap },
  { .name = "vop", .opt_idx = kOptViewoptions },
  { .name = "wop", .opt_idx = kOptWildoptions },
  { .name = "lsp", .opt_idx = kOptLinespace },
  { .name = "lop", .opt_idx = kOptLispoptions },
  { .name = "mmp", .opt_idx = kOptMaxmempattern },
  { .name = "top", .opt_idx = kOptTildeop },
  { .name = "isp", .opt_idx = kOptIsprint },
  { .name = "kmp", .opt_idx = kOptKeymap },
  { .name = "jop", .opt_idx = kOptJumpoptions },
  { .name = "rtp", .opt_idx = kOptRuntimepath },
  { .name = "flp", .opt_idx = kOptFormatlistpat },
  { .name = "sxq", .opt_idx = kOptShellxquote },
  { .name = "shq", .opt_idx = kOptShellquote },
  { .name = "dir", .opt_idx = kOptDirectory },
  { .name = "spr", .opt_idx = kOptSplitright },
  { .name = "sbr", .opt_idx = kOptShowbreak },
  { .name = "wbr", .opt_idx = kOptWinbar },
  { .name = "tsr", .opt_idx = kOptThesaurus },
  { .name = "lnr", .opt_idx = kOptLangnoremap },
  { .name = "srr", .opt_idx = kOptShellredir },
  { .name = "gcr", .opt_idx = kOptGuicursor },
  { .name = "lbr", .opt_idx = kOptLinebreak },
  { .name = "fmr", .opt_idx = kOptFoldmarker },
  { .name = "scr", .opt_idx = kOptScroll },
  { .name = "hls", .opt_idx = kOptHlsearch },
  { .name = "scs", .opt_idx = kOptSmartcase },
  { .name = "sms", .opt_idx = kOptSmoothscroll },
  { .name = "sts", .opt_idx = kOptSofttabstop },
  { .name = "sps", .opt_idx = kOptSpellsuggest },
  { .name = "fcs", .opt_idx = kOptFillchars },
  { .name = "ffs", .opt_idx = kOptFileformats },
  { .name = "vbs", .opt_idx = kOptVerbose },
  { .name = "cms", .opt_idx = kOptCommentstring },
  { .name = "tbs", .opt_idx = kOptTagbsearch },
  { .name = "lcs", .opt_idx = kOptListchars },
  { .name = "mps", .opt_idx = kOptMatchpairs },
  { .name = "mis", .opt_idx = kOptMenuitems },
  { .name = "vts", .opt_idx = kOptVartabstop },
  { .name = "ims", .opt_idx = kOptImsearch },
  { .name = "mls", .opt_idx = kOptModelines },
  { .name = "gtt", .opt_idx = kOptGuitabtooltip },
  { .name = "sft", .opt_idx = kOptShowfulltag },
  { .name = "rdt", .opt_idx = kOptRedrawtime },
  { .name = "cpt", .opt_idx = kOptComplete },
  { .name = "cot", .opt_idx = kOptCompleteopt },
  { .name = "mat", .opt_idx = kOptMatchtime },
  { .name = "fdt", .opt_idx = kOptFoldtext },
  { .name = "ffu", .opt_idx = kOptFindfunc },
  { .name = "ofu", .opt_idx = kOptOmnifunc },
  { .name = "tfu", .opt_idx = kOptTagfunc },
  { .name = "cfu", .opt_idx = kOptCompletefunc },
  { .name = "rnu", .opt_idx = kOptRelativenumber },
  { .name = "ccv", .opt_idx = kOptCharconvert },
  { .name = "pvw", .opt_idx = kOptPreviewwindow },
  { .name = "gfw", .opt_idx = kOptGuifontwide },
  { .name = "nuw", .opt_idx = kOptNumberwidth },
  { .name = "wfw", .opt_idx = kOptWinfixwidth },
  { .name = "wiw", .opt_idx = kOptWinwidth },
  { .name = "wmw", .opt_idx = kOptWinminwidth },
  { .name = "pex", .opt_idx = kOptPatchexpr },
  { .name = "pyx", .opt_idx = kOptPyxversion },
  { .name = "bex", .opt_idx = kOptBackupext },
  { .name = "dex", .opt_idx = kOptDiffexpr },
  { .name = "fex", .opt_idx = kOptFormatexpr },
  { .name = "para", .opt_idx = kOptParagraphs },
  { .name = "arab", .opt_idx = kOptArabic },
  { .name = "bomb", .opt_idx = kOptBomb },
  { .name = "sloc", .opt_idx = kOptShowcmdloc },
  { .name = "exrc", .opt_idx = kOptExrc },
  { .name = "fenc", .opt_idx = kOptFileencoding },
  { .name = "menc", .opt_idx = kOptMakeencoding },
  { .name = "tenc", .opt_idx = kOptTermencoding },
  { .name = "cole", .opt_idx = kOptConceallevel },
  { .name = "more", .opt_idx = kOptMore },
  { .name = "inde", .opt_idx = kOptIndentexpr },
  { .name = "shcf", .opt_idx = kOptShellcmdflag },
  { .name = "diff", .opt_idx = kOptDiff },
  { .name = "qftf", .opt_idx = kOptQuickfixtextfunc },
  { .name = "path", .opt_idx = kOptPath },
  { .name = "cink", .opt_idx = kOptCinkeys },
  { .name = "indk", .opt_idx = kOptIndentkeys },
  { .name = "scbk", .opt_idx = kOptScrollback },
  { .name = "stal", .opt_idx = kOptShowtabline },
  { .name = "icon", .opt_idx = kOptIcon },
  { .name = "warn", .opt_idx = kOptWarn },
  { .name = "deco", .opt_idx = kOptDelcombine },
  { .name = "cino", .opt_idx = kOptCinoptions },
  { .name = "siso", .opt_idx = kOptSidescrolloff },
  { .name = "ssop", .opt_idx = kOptSessionoptions },
  { .name = "stmp", .opt_idx = kOptShelltemp },
  { .name = "lisp", .opt_idx = kOptLisp },
  { .name = "wrap", .opt_idx = kOptWrap },
  { .name = "lmap", .opt_idx = kOptLangmap },
  { .name = "udir", .opt_idx = kOptUndodir },
  { .name = "vdir", .opt_idx = kOptViewdir },
  { .name = "bdir", .opt_idx = kOptBackupdir },
  { .name = "vsts", .opt_idx = kOptVarsofttabstop },
  { .name = "tags", .opt_idx = kOptTags },
  { .name = "fdls", .opt_idx = kOptFoldlevelstart },
  { .name = "tgst", .opt_idx = kOptTagstack },
  { .name = "mopt", .opt_idx = kOptMessagesopt },
  { .name = "list", .opt_idx = kOptList },
  { .name = "dict", .opt_idx = kOptDictionary },
  { .name = "sect", .opt_idx = kOptSections },
  { .name = "cocu", .opt_idx = kOptConcealcursor },
  { .name = "wmnu", .opt_idx = kOptWildmenu },
  { .name = "odev", .opt_idx = kOptOpendevice },
  { .name = "ambw", .opt_idx = kOptAmbiwidth },
  { .name = "cinw", .opt_idx = kOptCinwords },
  { .name = "inex", .opt_idx = kOptIncludeexpr },
  { .name = "aleph", .opt_idx = kOptAleph },
  { .name = "bsdir", .opt_idx = kOptBrowsedir },
  { .name = "cedit", .opt_idx = kOptCedit },
  { .name = "cinsd", .opt_idx = kOptCinscopedecls },
  { .name = "debug", .opt_idx = kOptDebug },
  { .name = "emoji", .opt_idx = kOptEmoji },
  { .name = "fsync", .opt_idx = kOptFsync },
  { .name = "fencs", .opt_idx = kOptFileencodings },
  { .name = "hkmap", .opt_idx = kOptHkmap },
  { .name = "lines", .opt_idx = kOptLines },
  { .name = "mouse", .opt_idx = kOptMouse },
  { .name = "magic", .opt_idx = kOptMagic },
  { .name = "paste", .opt_idx = kOptPaste },
  { .name = "remap", .opt_idx = kOptRemap },
  { .name = "ruler", .opt_idx = kOptRuler },
  { .name = "shell", .opt_idx = kOptShell },
  { .name = "spell", .opt_idx = kOptSpell },
  { .name = "shada", .opt_idx = kOptShada },
  { .name = "tsrfu", .opt_idx = kOptThesaurusfunc },
  { .name = "title", .opt_idx = kOptTitle },
  { .name = "terse", .opt_idx = kOptTerse },
  { .name = "tbidi", .opt_idx = kOptTermbidi },
  { .name = "vfile", .opt_idx = kOptVerbosefile },
  { .name = "winbl", .opt_idx = kOptWinblend },
  { .name = "write", .opt_idx = kOptWrite },
  { .name = "winhl", .opt_idx = kOptWinhighlight },
  { .name = "arabic", .opt_idx = kOptArabic },
  { .name = "backup", .opt_idx = kOptBackup },
  { .name = "secure", .opt_idx = kOptSecure },
  { .name = "hidden", .opt_idx = kOptHidden },
  { .name = "define", .opt_idx = kOptDefine },
  { .name = "opfunc", .opt_idx = kOptOperatorfunc },
  { .name = "cdhome", .opt_idx = kOptCdhome },
  { .name = "briopt", .opt_idx = kOptBreakindentopt },
  { .name = "makeef", .opt_idx = kOptMakeef },
  { .name = "culopt", .opt_idx = kOptCursorlineopt },
  { .name = "hkmapp", .opt_idx = kOptHkmapp },
  { .name = "number", .opt_idx = kOptNumber },
  { .name = "window", .opt_idx = kOptWindow },
  { .name = "winbar", .opt_idx = kOptWinbar },
  { .name = "syntax", .opt_idx = kOptSyntax },
  { .name = "binary", .opt_idx = kOptBinary },
  { .name = "prompt", .opt_idx = kOptPrompt },
  { .name = "cdpath", .opt_idx = kOptCdpath },
  { .name = "report", .opt_idx = kOptReport },
  { .name = "scroll", .opt_idx = kOptScroll },
  { .name = "mousef", .opt_idx = kOptMousefocus },
  { .name = "mousem", .opt_idx = kOptMousemodel },
  { .name = "mouses", .opt_idx = kOptMouseshape },
  { .name = "mouset", .opt_idx = kOptMousetime },
  { .name = "revins", .opt_idx = kOptRevins },
  { .name = "fixeol", .opt_idx = kOptFixendofline },
  { .name = "keymap", .opt_idx = kOptKeymap },
  { .name = "channel", .opt_idx = kOptChannel },
  { .name = "tabstop", .opt_idx = kOptTabstop },
  { .name = "tabline", .opt_idx = kOptTabline },
  { .name = "include", .opt_idx = kOptInclude },
  { .name = "undodir", .opt_idx = kOptUndodir },
  { .name = "breakat", .opt_idx = kOptBreakat },
  { .name = "viewdir", .opt_idx = kOptViewdir },
  { .name = "grepprg", .opt_idx = kOptGrepprg },
  { .name = "diffopt", .opt_idx = kOptDiffopt },
  { .name = "buftype", .opt_idx = kOptBuftype },
  { .name = "isfname", .opt_idx = kOptIsfname },
  { .name = "digraph", .opt_idx = kOptDigraph },
  { .name = "tagcase", .opt_idx = kOptTagcase },
  { .name = "tagfunc", .opt_idx = kOptTagfunc },
  { .name = "isident", .opt_idx = kOptIsident },
  { .name = "guifont", .opt_idx = kOptGuifont },
  { .name = "makeprg", .opt_idx = kOptMakeprg },
  { .name = "belloff", .opt_idx = kOptBelloff },
  { .name = "columns", .opt_idx = kOptColumns },
  { .name = "tildeop", .opt_idx = kOptTildeop },
  { .name = "timeout", .opt_idx = kOptTimeout },
  { .name = "viminfo", .opt_idx = kOptShada },
  { .name = "confirm", .opt_idx = kOptConfirm },
  { .name = "cindent", .opt_idx = kOptCindent },
  { .name = "cinkeys", .opt_idx = kOptCinkeys },
  { .name = "langmap", .opt_idx = kOptLangmap },
  { .name = "showcmd", .opt_idx = kOptShowcmd },
  { .name = "isprint", .opt_idx = kOptIsprint },
  { .name = "verbose", .opt_idx = kOptVerbose },
  { .name = "history", .opt_idx = kOptHistory },
  { .name = "display", .opt_idx = kOptDisplay },
  { .name = "arshape", .opt_idx = kOptArabicshape },
  { .name = "casemap", .opt_idx = kOptCasemap },
  { .name = "ttyfast", .opt_idx = kOptTtyfast },
  { .name = "autoread", .opt_idx = kOptAutoread },
  { .name = "complete", .opt_idx = kOptComplete },
  { .name = "cinwords", .opt_idx = kOptCinwords },
  { .name = "comments", .opt_idx = kOptComments },
  { .name = "diffexpr", .opt_idx = kOptDiffexpr },
  { .name = "encoding", .opt_idx = kOptEncoding },
  { .name = "equalprg", .opt_idx = kOptEqualprg },
  { .name = "filetype", .opt_idx = kOptFiletype },
  { .name = "findfunc", .opt_idx = kOptFindfunc },
  { .name = "foldexpr", .opt_idx = kOptFoldexpr },
  { .name = "foldopen", .opt_idx = kOptFoldopen },
  { .name = "foldtext", .opt_idx = kOptFoldtext },
  { .name = "gdefault", .opt_idx = kOptGdefault },
  { .name = "helplang", .opt_idx = kOptHelplang },
  { .name = "hlsearch", .opt_idx = kOptHlsearch },
  { .name = "helpfile", .opt_idx = kOptHelpfile },
  { .name = "iminsert", .opt_idx = kOptIminsert },
  { .name = "imsearch", .opt_idx = kOptImsearch },
  { .name = "keymodel", .opt_idx = kOptKeymodel },
  { .name = "langmenu", .opt_idx = kOptLangmenu },
  { .name = "modified", .opt_idx = kOptModified },
  { .name = "modeline", .opt_idx = kOptModeline },
  { .name = "mousemev", .opt_idx = kOptMousemoveevent },
  { .name = "omnifunc", .opt_idx = kOptOmnifunc },
  { .name = "packpath", .opt_idx = kOptPackpath },
  { .name = "pumblend", .opt_idx = kOptPumblend },
  { .name = "pumwidth", .opt_idx = kOptPumwidth },
  { .name = "readonly", .opt_idx = kOptReadonly },
  { .name = "showmode", .opt_idx = kOptShowmode },
  { .name = "smarttab", .opt_idx = kOptSmarttab },
  { .name = "swapfile", .opt_idx = kOptSwapfile },
  { .name = "suffixes", .opt_idx = kOptSuffixes },
  { .name = "sections", .opt_idx = kOptSections },
  { .name = "ttimeout", .opt_idx = kOptTtimeout },
  { .name = "tabclose", .opt_idx = kOptTabclose },
  { .name = "termbidi", .opt_idx = kOptTermbidi },
  { .name = "titleold", .opt_idx = kOptTitleold },
  { .name = "titlelen", .opt_idx = kOptTitlelen },
  { .name = "termsync", .opt_idx = kOptTermsync },
  { .name = "tagstack", .opt_idx = kOptTagstack },
  { .name = "undofile", .opt_idx = kOptUndofile },
  { .name = "wildchar", .opt_idx = kOptWildchar },
  { .name = "winblend", .opt_idx = kOptWinblend },
  { .name = "winwidth", .opt_idx = kOptWinwidth },
  { .name = "wrapscan", .opt_idx = kOptWrapscan },
  { .name = "writeany", .opt_idx = kOptWriteany },
  { .name = "wildmode", .opt_idx = kOptWildmode },
  { .name = "wildmenu", .opt_idx = kOptWildmenu },
  { .name = "smartcase", .opt_idx = kOptSmartcase },
  { .name = "shadafile", .opt_idx = kOptShadafile },
  { .name = "ambiwidth", .opt_idx = kOptAmbiwidth },
  { .name = "backupdir", .opt_idx = kOptBackupdir },
  { .name = "backupext", .opt_idx = kOptBackupext },
  { .name = "imcmdline", .opt_idx = kOptImcmdline },
  { .name = "incsearch", .opt_idx = kOptIncsearch },
  { .name = "backspace", .opt_idx = kOptBackspace },
  { .name = "endoffile", .opt_idx = kOptEndoffile },
  { .name = "endofline", .opt_idx = kOptEndofline },
  { .name = "cmdheight", .opt_idx = kOptCmdheight },
  { .name = "imdisable", .opt_idx = kOptImdisable },
  { .name = "modelines", .opt_idx = kOptModelines },
  { .name = "spelllang", .opt_idx = kOptSpelllang },
  { .name = "shelltemp", .opt_idx = kOptShelltemp },
  { .name = "thesaurus", .opt_idx = kOptThesaurus },
  { .name = "spellfile", .opt_idx = kOptSpellfile },
  { .name = "shellpipe", .opt_idx = kOptShellpipe },
  { .name = "bufhidden", .opt_idx = kOptBufhidden },
  { .name = "buflisted", .opt_idx = kOptBuflisted },
  { .name = "nrformats", .opt_idx = kOptNrformats },
  { .name = "infercase", .opt_idx = kOptInfercase },
  { .name = "highlight", .opt_idx = kOptHighlight },
  { .name = "taglength", .opt_idx = kOptTaglength },
  { .name = "rightleft", .opt_idx = kOptRightleft },
  { .name = "guicursor", .opt_idx = kOptGuicursor },
  { .name = "whichwrap", .opt_idx = kOptWhichwrap },
  { .name = "clipboard", .opt_idx = kOptClipboard },
  { .name = "switchbuf", .opt_idx = kOptSwitchbuf },
  { .name = "iskeyword", .opt_idx = kOptIskeyword },
  { .name = "selection", .opt_idx = kOptSelection },
  { .name = "splitkeep", .opt_idx = kOptSplitkeep },
  { .name = "fillchars", .opt_idx = kOptFillchars },
  { .name = "foldclose", .opt_idx = kOptFoldclose },
  { .name = "wildcharm", .opt_idx = kOptWildcharm },
  { .name = "foldlevel", .opt_idx = kOptFoldlevel },
  { .name = "pumheight", .opt_idx = kOptPumheight },
  { .name = "synmaxcol", .opt_idx = kOptSynmaxcol },
  { .name = "linebreak", .opt_idx = kOptLinebreak },
  { .name = "winheight", .opt_idx = kOptWinheight },
  { .name = "linespace", .opt_idx = kOptLinespace },
  { .name = "menuitems", .opt_idx = kOptMenuitems },
  { .name = "winfixbuf", .opt_idx = kOptWinfixbuf },
  { .name = "langremap", .opt_idx = kOptLangremap },
  { .name = "cpoptions", .opt_idx = kOptCpoptions },
  { .name = "showmatch", .opt_idx = kOptShowmatch },
  { .name = "browsedir", .opt_idx = kOptBrowsedir },
  { .name = "shortmess", .opt_idx = kOptShortmess },
  { .name = "showbreak", .opt_idx = kOptShowbreak },
  { .name = "expandtab", .opt_idx = kOptExpandtab },
  { .name = "formatprg", .opt_idx = kOptFormatprg },
  { .name = "directory", .opt_idx = kOptDirectory },
  { .name = "errorfile", .opt_idx = kOptErrorfile },
  { .name = "scrolloff", .opt_idx = kOptScrolloff },
  { .name = "scrollopt", .opt_idx = kOptScrollopt },
  { .name = "lispwords", .opt_idx = kOptLispwords },
  { .name = "listchars", .opt_idx = kOptListchars },
  { .name = "autochdir", .opt_idx = kOptAutochdir },
  { .name = "autowrite", .opt_idx = kOptAutowrite },
  { .name = "patchexpr", .opt_idx = kOptPatchexpr },
  { .name = "patchmode", .opt_idx = kOptPatchmode },
  { .name = "matchtime", .opt_idx = kOptMatchtime },
  { .name = "mousehide", .opt_idx = kOptMousehide },
  { .name = "mousetime", .opt_idx = kOptMousetime },
  { .name = "textwidth", .opt_idx = kOptTextwidth },
  { .name = "foldenable", .opt_idx = kOptFoldenable },
  { .name = "paragraphs", .opt_idx = kOptParagraphs },
  { .name = "tagbsearch", .opt_idx = kOptTagbsearch },
  { .name = "matchpairs", .opt_idx = kOptMatchpairs },
  { .name = "joinspaces", .opt_idx = kOptJoinspaces },
  { .name = "laststatus", .opt_idx = kOptLaststatus },
  { .name = "modifiable", .opt_idx = kOptModifiable },
  { .name = "cursorbind", .opt_idx = kOptCursorbind },
  { .name = "visualbell", .opt_idx = kOptVisualbell },
  { .name = "maxcombine", .opt_idx = kOptMaxcombine },
  { .name = "scrollback", .opt_idx = kOptScrollback },
  { .name = "delcombine", .opt_idx = kOptDelcombine },
  { .name = "scrollbind", .opt_idx = kOptScrollbind },
  { .name = "ignorecase", .opt_idx = kOptIgnorecase },
  { .name = "backupcopy", .opt_idx = kOptBackupcopy },
  { .name = "copyindent", .opt_idx = kOptCopyindent },
  { .name = "showcmdloc", .opt_idx = kOptShowcmdloc },
  { .name = "autoindent", .opt_idx = kOptAutoindent },
  { .name = "keywordprg", .opt_idx = kOptKeywordprg },
  { .name = "lazyredraw", .opt_idx = kOptLazyredraw },
  { .name = "errorbells", .opt_idx = kOptErrorbells },
  { .name = "tabpagemax", .opt_idx = kOptTabpagemax },
  { .name = "writedelay", .opt_idx = kOptWritedelay },
  { .name = "shellredir", .opt_idx = kOptShellredir },
  { .name = "indentexpr", .opt_idx = kOptIndentexpr },
  { .name = "splitbelow", .opt_idx = kOptSplitbelow },
  { .name = "formatexpr", .opt_idx = kOptFormatexpr },
  { .name = "mouseshape", .opt_idx = kOptMouseshape },
  { .name = "guioptions", .opt_idx = kOptGuioptions },
  { .name = "helpheight", .opt_idx = kOptHelpheight },
  { .name = "cinoptions", .opt_idx = kOptCinoptions },
  { .name = "compatible", .opt_idx = kOptCompatible },
  { .name = "shiftwidth", .opt_idx = kOptShiftwidth },
  { .name = "splitright", .opt_idx = kOptSplitright },
  { .name = "scrolljump", .opt_idx = kOptScrolljump },
  { .name = "winaltkeys", .opt_idx = kOptWinaltkeys },
  { .name = "indentkeys", .opt_idx = kOptIndentkeys },
  { .name = "cursorline", .opt_idx = kOptCursorline },
  { .name = "signcolumn", .opt_idx = kOptSigncolumn },
  { .name = "foldcolumn", .opt_idx = kOptFoldcolumn },
  { .name = "mkspellmem", .opt_idx = kOptMkspellmem },
  { .name = "shellslash", .opt_idx = kOptShellslash },
  { .name = "undoreload", .opt_idx = kOptUndoreload },
  { .name = "statusline", .opt_idx = kOptStatusline },
  { .name = "selectmode", .opt_idx = kOptSelectmode },
  { .name = "insertmode", .opt_idx = kOptInsertmode },
  { .name = "inccommand", .opt_idx = kOptInccommand },
  { .name = "dictionary", .opt_idx = kOptDictionary },
  { .name = "foldignore", .opt_idx = kOptFoldignore },
  { .name = "wildignore", .opt_idx = kOptWildignore },
  { .name = "background", .opt_idx = kOptBackground },
  { .name = "mousefocus", .opt_idx = kOptMousefocus },
  { .name = "shiftround", .opt_idx = kOptShiftround },
  { .name = "mousemodel", .opt_idx = kOptMousemodel },
  { .name = "grepformat", .opt_idx = kOptGrepformat },
  { .name = "sidescroll", .opt_idx = kOptSidescroll },
  { .name = "fileformat", .opt_idx = kOptFileformat },
  { .name = "iconstring", .opt_idx = kOptIconstring },
  { .name = "wrapmargin", .opt_idx = kOptWrapmargin },
  { .name = "foldmarker", .opt_idx = kOptFoldmarker },
  { .name = "backupskip", .opt_idx = kOptBackupskip },
  { .name = "vartabstop", .opt_idx = kOptVartabstop },
  { .name = "pyxversion", .opt_idx = kOptPyxversion },
  { .name = "updatetime", .opt_idx = kOptUpdatetime },
  { .name = "timeoutlen", .opt_idx = kOptTimeoutlen },
  { .name = "foldmethod", .opt_idx = kOptFoldmethod },
  { .name = "redrawtime", .opt_idx = kOptRedrawtime },
  { .name = "shellquote", .opt_idx = kOptShellquote },
  { .name = "opendevice", .opt_idx = kOptOpendevice },
  { .name = "undolevels", .opt_idx = kOptUndolevels },
  { .name = "showtabline", .opt_idx = kOptShowtabline },
  { .name = "equalalways", .opt_idx = kOptEqualalways },
  { .name = "virtualedit", .opt_idx = kOptVirtualedit },
  { .name = "softtabstop", .opt_idx = kOptSofttabstop },
  { .name = "guitablabel", .opt_idx = kOptGuitablabel },
  { .name = "writebackup", .opt_idx = kOptWritebackup },
  { .name = "arabicshape", .opt_idx = kOptArabicshape },
  { .name = "colorcolumn", .opt_idx = kOptColorcolumn },
  { .name = "includeexpr", .opt_idx = kOptIncludeexpr },
  { .name = "quoteescape", .opt_idx = kOptQuoteescape },
  { .name = "eadirection", .opt_idx = kOptEadirection },
  { .name = "completeopt", .opt_idx = kOptCompleteopt },
  { .name = "updatecount", .opt_idx = kOptUpdatecount },
  { .name = "foldnestmax", .opt_idx = kOptFoldnestmax },
  { .name = "errorformat", .opt_idx = kOptErrorformat },
  { .name = "viminfofile", .opt_idx = kOptShadafile },
  { .name = "rulerformat", .opt_idx = kOptRulerformat },
  { .name = "messagesopt", .opt_idx = kOptMessagesopt },
  { .name = "smartindent", .opt_idx = kOptSmartindent },
  { .name = "eventignore", .opt_idx = kOptEventignore },
  { .name = "breakindent", .opt_idx = kOptBreakindent },
  { .name = "tagrelative", .opt_idx = kOptTagrelative },
  { .name = "loadplugins", .opt_idx = kOptLoadplugins },
  { .name = "runtimepath", .opt_idx = kOptRuntimepath },
  { .name = "guifontwide", .opt_idx = kOptGuifontwide },
  { .name = "winminwidth", .opt_idx = kOptWinminwidth },
  { .name = "startofline", .opt_idx = kOptStartofline },
  { .name = "fileformats", .opt_idx = kOptFileformats },
  { .name = "ttimeoutlen", .opt_idx = kOptTtimeoutlen },
  { .name = "charconvert", .opt_idx = kOptCharconvert },
  { .name = "langnoremap", .opt_idx = kOptLangnoremap },
  { .name = "viewoptions", .opt_idx = kOptViewoptions },
  { .name = "wildoptions", .opt_idx = kOptWildoptions },
  { .name = "lispoptions", .opt_idx = kOptLispoptions },
  { .name = "maxmapdepth", .opt_idx = kOptMaxmapdepth },
  { .name = "jumpoptions", .opt_idx = kOptJumpoptions },
  { .name = "allowrevins", .opt_idx = kOptAllowrevins },
  { .name = "numberwidth", .opt_idx = kOptNumberwidth },
  { .name = "mousescroll", .opt_idx = kOptMousescroll },
  { .name = "titlestring", .opt_idx = kOptTitlestring },
  { .name = "verbosefile", .opt_idx = kOptVerbosefile },
  { .name = "pastetoggle", .opt_idx = kOptPastetoggle },
  { .name = "showfulltag", .opt_idx = kOptShowfulltag },
  { .name = "redrawdebug", .opt_idx = kOptRedrawdebug },
  { .name = "shellxquote", .opt_idx = kOptShellxquote },
  { .name = "winfixwidth", .opt_idx = kOptWinfixwidth },
  { .name = "suffixesadd", .opt_idx = kOptSuffixesadd },
  { .name = "statuscolumn", .opt_idx = kOptStatuscolumn },
  { .name = "edcompatible", .opt_idx = kOptEdcompatible },
  { .name = "cmdwinheight", .opt_idx = kOptCmdwinheight },
  { .name = "modelineexpr", .opt_idx = kOptModelineexpr },
  { .name = "operatorfunc", .opt_idx = kOptOperatorfunc },
  { .name = "shellxescape", .opt_idx = kOptShellxescape },
  { .name = "spellsuggest", .opt_idx = kOptSpellsuggest },
  { .name = "spelloptions", .opt_idx = kOptSpelloptions },
  { .name = "shellcmdflag", .opt_idx = kOptShellcmdflag },
  { .name = "regexpengine", .opt_idx = kOptRegexpengine },
  { .name = "rightleftcmd", .opt_idx = kOptRightleftcmd },
  { .name = "makeencoding", .opt_idx = kOptMakeencoding },
  { .name = "fileencoding", .opt_idx = kOptFileencoding },
  { .name = "foldminlines", .opt_idx = kOptFoldminlines },
  { .name = "completefunc", .opt_idx = kOptCompletefunc },
  { .name = "conceallevel", .opt_idx = kOptConceallevel },
  { .name = "winfixheight", .opt_idx = kOptWinfixheight },
  { .name = "winminheight", .opt_idx = kOptWinminheight },
  { .name = "winhighlight", .opt_idx = kOptWinhighlight },
  { .name = "smoothscroll", .opt_idx = kOptSmoothscroll },
  { .name = "cursorcolumn", .opt_idx = kOptCursorcolumn },
  { .name = "termencoding", .opt_idx = kOptTermencoding },
  { .name = "autowriteall", .opt_idx = kOptAutowriteall },
  { .name = "fixendofline", .opt_idx = kOptFixendofline },
  { .name = "maxfuncdepth", .opt_idx = kOptMaxfuncdepth },
  { .name = "concealcursor", .opt_idx = kOptConcealcursor },
  { .name = "guitabtooltip", .opt_idx = kOptGuitabtooltip },
  { .name = "sidescrolloff", .opt_idx = kOptSidescrolloff },
  { .name = "spellcapcheck", .opt_idx = kOptSpellcapcheck },
  { .name = "previewheight", .opt_idx = kOptPreviewheight },
  { .name = "completeslash", .opt_idx = kOptCompleteslash },
  { .name = "previewwindow", .opt_idx = kOptPreviewwindow },
  { .name = "maxmempattern", .opt_idx = kOptMaxmempattern },
  { .name = "fileencodings", .opt_idx = kOptFileencodings },
  { .name = "commentstring", .opt_idx = kOptCommentstring },
  { .name = "cinscopedecls", .opt_idx = kOptCinscopedecls },
  { .name = "cursorlineopt", .opt_idx = kOptCursorlineopt },
  { .name = "formatoptions", .opt_idx = kOptFormatoptions },
  { .name = "formatlistpat", .opt_idx = kOptFormatlistpat },
  { .name = "termguicolors", .opt_idx = kOptTermguicolors },
  { .name = "thesaurusfunc", .opt_idx = kOptThesaurusfunc },
  { .name = "breakindentopt", .opt_idx = kOptBreakindentopt },
  { .name = "fileignorecase", .opt_idx = kOptFileignorecase },
  { .name = "foldlevelstart", .opt_idx = kOptFoldlevelstart },
  { .name = "mousemoveevent", .opt_idx = kOptMousemoveevent },
  { .name = "preserveindent", .opt_idx = kOptPreserveindent },
  { .name = "relativenumber", .opt_idx = kOptRelativenumber },
  { .name = "sessionoptions", .opt_idx = kOptSessionoptions },
  { .name = "varsofttabstop", .opt_idx = kOptVarsofttabstop },
  { .name = "wildignorecase", .opt_idx = kOptWildignorecase },
  { .name = "termpastefilter", .opt_idx = kOptTermpastefilter },
  { .name = "quickfixtextfunc", .opt_idx = kOptQuickfixtextfunc },
  { .name = "completeitemalign", .opt_idx = kOptCompleteitemalign },
};

static int find_option_hash(const char *str, size_t len)
{
  int low = 0, high = 0;
  switch (len) {
    case 2: switch (str[1]) {
      case 'a': low = 0; high = 4; break;
      case 'b': low = 4; high = 10; break;
      case 'c': low = 10; high = 16; break;
      case 'd': low = 16; high = 21; break;
      case 'e': low = 21; high = 24; break;
      case 'f': low = 24; high = 30; break;
      case 'g': low = 30; high = 32; break;
      case 'h': low = 32; high = 39; break;
      case 'i': low = 39; high = 48; break;
      case 'j': low = 48; high = 49; break;
      case 'k': low = 49; high = 51; break;
      case 'l': low = 51; high = 58; break;
      case 'm': low = 58; high = 65; break;
      case 'o': low = 65; high = 72; break;
      case 'p': low = 72; high = 80; break;
      case 'r': low = 80; high = 84; break;
      case 's': low = 84; high = 92; break;
      case 't': low = 92; high = 97; break;
      case 'u': low = 97; high = 100; break;
      case 'w': low = 100; high = 106; break;
      case 'x': low = 106; high = 107; break;
      case 'y': low = 107; high = 108; break;
      case 'z': low = 108; high = 109; break;
      default: break;
    }
    break;
    case 3: switch (str[2]) {
      case 'a': low = 109; high = 113; break;
      case 'b': low = 113; high = 118; break;
      case 'c': low = 118; high = 131; break;
      case 'd': low = 131; high = 139; break;
      case 'e': low = 139; high = 142; break;
      case 'f': low = 142; high = 154; break;
      case 'g': low = 154; high = 157; break;
      case 'h': low = 157; high = 162; break;
      case 'i': low = 162; high = 167; break;
      case 'k': low = 167; high = 172; break;
      case 'l': low = 172; high = 188; break;
      case 'm': low = 188; high = 201; break;
      case 'n': low = 201; high = 207; break;
      case 'o': low = 207; high = 213; break;
      case 'p': low = 213; high = 227; break;
      case 'q': low = 227; high = 229; break;
      case 'r': low = 229; high = 240; break;
      case 's': low = 240; high = 256; break;
      case 't': low = 256; high = 263; break;
      case 'u': low = 263; high = 268; break;
      case 'v': low = 268; high = 269; break;
      case 'w': low = 269; high = 275; break;
      case 'x': low = 275; high = 280; break;
      default: break;
    }
    break;
    case 4: switch (str[3]) {
      case 'a': low = 280; high = 281; break;
      case 'b': low = 281; high = 283; break;
      case 'c': low = 283; high = 288; break;
      case 'e': low = 288; high = 291; break;
      case 'f': low = 291; high = 294; break;
      case 'h': low = 294; high = 295; break;
      case 'k': low = 295; high = 298; break;
      case 'l': low = 298; high = 299; break;
      case 'n': low = 299; high = 301; break;
      case 'o': low = 301; high = 304; break;
      case 'p': low = 304; high = 309; break;
      case 'r': low = 309; high = 312; break;
      case 's': low = 312; high = 315; break;
      case 't': low = 315; high = 320; break;
      case 'u': low = 320; high = 322; break;
      case 'v': low = 322; high = 323; break;
      case 'w': low = 323; high = 325; break;
      case 'x': low = 325; high = 326; break;
      default: break;
    }
    break;
    case 5: switch (str[0]) {
      case 'a': low = 326; high = 327; break;
      case 'b': low = 327; high = 328; break;
      case 'c': low = 328; high = 330; break;
      case 'd': low = 330; high = 331; break;
      case 'e': low = 331; high = 332; break;
      case 'f': low = 332; high = 334; break;
      case 'h': low = 334; high = 335; break;
      case 'l': low = 335; high = 336; break;
      case 'm': low = 336; high = 338; break;
      case 'p': low = 338; high = 339; break;
      case 'r': low = 339; high = 341; break;
      case 's': low = 341; high = 344; break;
      case 't': low = 344; high = 348; break;
      case 'v': low = 348; high = 349; break;
      case 'w': low = 349; high = 352; break;
      default: break;
    }
    break;
    case 6: switch (str[2]) {
      case 'a': low = 352; high = 353; break;
      case 'c': low = 353; high = 355; break;
      case 'd': low = 355; high = 356; break;
      case 'f': low = 356; high = 358; break;
      case 'h': low = 358; high = 359; break;
      case 'i': low = 359; high = 360; break;
      case 'k': low = 360; high = 361; break;
      case 'l': low = 361; high = 362; break;
      case 'm': low = 362; high = 364; break;
      case 'n': low = 364; high = 368; break;
      case 'o': low = 368; high = 369; break;
      case 'p': low = 369; high = 371; break;
      case 'r': low = 371; high = 372; break;
      case 'u': low = 372; high = 376; break;
      case 'v': low = 376; high = 377; break;
      case 'x': low = 377; high = 378; break;
      case 'y': low = 378; high = 379; break;
      default: break;
    }
    break;
    case 7: switch (str[2]) {
      case 'a': low = 379; high = 380; break;
      case 'b': low = 380; high = 382; break;
      case 'c': low = 382; high = 383; break;
      case 'd': low = 383; high = 384; break;
      case 'e': low = 384; high = 387; break;
      case 'f': low = 387; high = 390; break;
      case 'g': low = 390; high = 393; break;
      case 'i': low = 393; high = 395; break;
      case 'k': low = 395; high = 396; break;
      case 'l': low = 396; high = 399; break;
      case 'm': low = 399; high = 401; break;
      case 'n': low = 401; high = 405; break;
      case 'o': low = 405; high = 406; break;
      case 'p': low = 406; high = 407; break;
      case 'r': low = 407; high = 408; break;
      case 's': low = 408; high = 412; break;
      case 'y': low = 412; high = 413; break;
      default: break;
    }
    break;
    case 8: switch (str[0]) {
      case 'a': low = 413; high = 414; break;
      case 'c': low = 414; high = 417; break;
      case 'd': low = 417; high = 418; break;
      case 'e': low = 418; high = 420; break;
      case 'f': low = 420; high = 425; break;
      case 'g': low = 425; high = 426; break;
      case 'h': low = 426; high = 429; break;
      case 'i': low = 429; high = 431; break;
      case 'k': low = 431; high = 432; break;
      case 'l': low = 432; high = 433; break;
      case 'm': low = 433; high = 436; break;
      case 'o': low = 436; high = 437; break;
      case 'p': low = 437; high = 440; break;
      case 'r': low = 440; high = 441; break;
      case 's': low = 441; high = 446; break;
      case 't': low = 446; high = 453; break;
      case 'u': low = 453; high = 454; break;
      case 'w': low = 454; high = 461; break;
      default: break;
    }
    break;
    case 9: switch (str[2]) {
      case 'a': low = 461; high = 463; break;
      case 'b': low = 463; high = 464; break;
      case 'c': low = 464; high = 469; break;
      case 'd': low = 469; high = 474; break;
      case 'e': low = 474; high = 479; break;
      case 'f': low = 479; high = 483; break;
      case 'g': low = 483; high = 486; break;
      case 'i': low = 486; high = 490; break;
      case 'k': low = 490; high = 491; break;
      case 'l': low = 491; high = 497; break;
      case 'm': low = 497; high = 498; break;
      case 'n': low = 498; high = 505; break;
      case 'o': low = 505; high = 510; break;
      case 'p': low = 510; high = 511; break;
      case 'r': low = 511; high = 516; break;
      case 's': low = 516; high = 518; break;
      case 't': low = 518; high = 523; break;
      case 'u': low = 523; high = 525; break;
      case 'x': low = 525; high = 526; break;
      default: break;
    }
    break;
    case 10: switch (str[6]) {
      case 'a': low = 526; high = 533; break;
      case 'b': low = 533; high = 539; break;
      case 'c': low = 539; high = 541; break;
      case 'd': low = 541; high = 546; break;
      case 'e': low = 546; high = 553; break;
      case 'h': low = 553; high = 554; break;
      case 'i': low = 554; high = 560; break;
      case 'j': low = 560; high = 561; break;
      case 'k': low = 561; high = 563; break;
      case 'l': low = 563; high = 570; break;
      case 'm': low = 570; high = 573; break;
      case 'n': low = 573; high = 576; break;
      case 'o': low = 576; high = 580; break;
      case 'r': low = 580; high = 586; break;
      case 's': low = 586; high = 589; break;
      case 't': low = 589; high = 593; break;
      case 'u': low = 593; high = 594; break;
      case 'v': low = 594; high = 596; break;
      default: break;
    }
    break;
    case 11: switch (str[5]) {
      case 'a': low = 596; high = 600; break;
      case 'b': low = 600; high = 602; break;
      case 'c': low = 602; high = 604; break;
      case 'd': low = 604; high = 605; break;
      case 'e': low = 605; high = 610; break;
      case 'f': low = 610; high = 613; break;
      case 'g': low = 613; high = 614; break;
      case 'i': low = 614; high = 617; break;
      case 'l': low = 617; high = 619; break;
      case 'm': low = 619; high = 620; break;
      case 'n': low = 620; high = 622; break;
      case 'o': low = 622; high = 627; break;
      case 'p': low = 627; high = 632; break;
      case 'r': low = 632; high = 634; break;
      case 's': low = 634; high = 637; break;
      case 't': low = 637; high = 638; break;
      case 'u': low = 638; high = 639; break;
      case 'w': low = 639; high = 640; break;
      case 'x': low = 640; high = 643; break;
      default: break;
    }
    break;
    case 12: switch (str[2]) {
      case 'a': low = 643; high = 644; break;
      case 'c': low = 644; high = 645; break;
      case 'd': low = 645; high = 647; break;
      case 'e': low = 647; high = 652; break;
      case 'g': low = 652; high = 654; break;
      case 'k': low = 654; high = 655; break;
      case 'l': low = 655; high = 657; break;
      case 'm': low = 657; high = 658; break;
      case 'n': low = 658; high = 662; break;
      case 'o': low = 662; high = 663; break;
      case 'r': low = 663; high = 665; break;
      case 't': low = 665; high = 666; break;
      case 'x': low = 666; high = 668; break;
      default: break;
    }
    break;
    case 13: switch (str[5]) {
      case 'a': low = 668; high = 669; break;
      case 'b': low = 669; high = 670; break;
      case 'c': low = 670; high = 672; break;
      case 'e': low = 672; high = 675; break;
      case 'm': low = 675; high = 676; break;
      case 'n': low = 676; high = 678; break;
      case 'o': low = 678; high = 679; break;
      case 'r': low = 679; high = 680; break;
      case 't': low = 680; high = 682; break;
      case 'u': low = 682; high = 684; break;
      default: break;
    }
    break;
    case 14: switch (str[0]) {
      case 'b': low = 684; high = 685; break;
      case 'f': low = 685; high = 687; break;
      case 'm': low = 687; high = 688; break;
      case 'p': low = 688; high = 689; break;
      case 'r': low = 689; high = 690; break;
      case 's': low = 690; high = 691; break;
      case 'v': low = 691; high = 692; break;
      case 'w': low = 692; high = 693; break;
      default: break;
    }
    break;
    case 15: low = 693; high = 694; break;
    case 16: low = 694; high = 695; break;
    case 17: low = 695; high = 696; break;
    default: break;
  }
  for (int i = low; i < high; i++) {
    if (!memcmp(str, option_hash_elems[i].name, len)) {
      return i;
    }
  }
  return -1;
}


